tbb::flow::interface11::split_node< TupleType, Allocator > Class Template Reference

split_node: accepts a tuple as input, forwards each element of the tuple to its More...

`#include <flow_graph.h>`

Inheritance diagram for tbb::flow::interface11::split_node< TupleType, Allocator >:
Collaboration diagram for tbb::flow::interface11::split_node< TupleType, Allocator >:

## Public Types

typedef TupleType | input_type
typedef Allocator | allocator_type
typedef internal::wrap_tuple_elements< N, internal::multifunction_output, TupleType >::type | output_ports_type
Public Types inherited from tbb::flow::interface11::internal::untyped_receiver
typedef untyped_sender | predecessor_type
| The predecessor type for this node. More...

## Public Member Functions

__TBB_NOINLINE_SYM | split_node (graph &g)
__TBB_NOINLINE_SYM | split_node (const split_node &other)
output_ports_type & | output_ports ()
Public Member Functions inherited from tbb::flow::interface11::graph_node
| graph_node (graph &g)
virtual | ~graph_node ()
Public Member Functions inherited from tbb::flow::interface11::receiver< TupleType >
bool | try_put (const typename internal::async_helpers< TupleType >::filtered_type &t)
| Put an item to the receiver. More...
bool | try_put (const typename internal::async_helpers< TupleType >::async_type &t)
Public Member Functions inherited from tbb::flow::interface11::internal::untyped_receiver
virtual | ~untyped_receiver ()
| Destructor. More...
template<typename X >
bool | try_put (const X &t)
| Put an item to the receiver. More...
virtual bool | register_predecessor (predecessor_type &)
| Add a predecessor to the node. More...
virtual bool | remove_predecessor (predecessor_type &)
| Remove a predecessor from the node. More...

## Protected Member Functions

task * | try_put_task (const TupleType &t) __TBB_override
| Put item to successor; return task to run the successor if possible. More...
void | reset_node (reset_flags f) __TBB_override
void | reset_receiver (reset_flags) __TBB_override
| put receiver back in initial state More...
graph & | graph_reference () const __TBB_override
Protected Member Functions inherited from tbb::flow::interface11::receiver< TupleType >
virtual task * | try_put_task_wrapper (const void *p, bool is_async) __TBB_override
Protected Member Functions inherited from tbb::flow::interface11::internal::untyped_receiver
template<typename X >
task * | try_put_task (const X &t)
virtual bool | is_continue_receiver ()

## Private Types

typedef receiver< TupleType > | base_type

## Private Attributes

output_ports_type | my_output_ports

## Static Private Attributes

static const int | N = tbb::flow::tuple_size<TupleType>::value

## Additional Inherited Members

Public Attributes inherited from tbb::flow::interface11::receiver< TupleType >
__TBB_DEPRECATED typedef TupleType | input_type
| The input type of this receiver. More...
__TBB_DEPRECATED typedef internal::async_helpers< TupleType >::filtered_type | filtered_type
Protected Attributes inherited from tbb::flow::interface11::graph_node
graph & | my_graph
graph_node * | next
graph_node * | prev

## Detailed Description

### template<typename TupleType, typename Allocator = cache_aligned_allocator<TupleType>>
class tbb::flow::interface11::split_node< TupleType, Allocator >

split_node: accepts a tuple as input, forwards each element of the tuple to its

Definition at line 1349 of file flow_graph.h.

## Member Typedef Documentation

## allocator_type

template<typename TupleType , typename Allocator = cache_aligned_allocator<TupleType>>

typedef Allocator tbb::flow::interface11::split_node< TupleType, Allocator >::allocator_type

Definition at line 1354 of file flow_graph.h.

## base_type

template<typename TupleType , typename Allocator = cache_aligned_allocator<TupleType>>

typedef receiver<TupleType> tbb::flow::interface11::split_node< TupleType, Allocator >::base_type

private

Definition at line 1351 of file flow_graph.h.

## input_type

template<typename TupleType , typename Allocator = cache_aligned_allocator<TupleType>>

typedef TupleType tbb::flow::interface11::split_node< TupleType, Allocator >::input_type

Definition at line 1353 of file flow_graph.h.

## output_ports_type

template<typename TupleType , typename Allocator = cache_aligned_allocator<TupleType>>

typedef internal::wrap_tuple_elements< N, internal::multifunction_output, TupleType >::type tbb::flow::interface11::split_node< TupleType, Allocator >::output_ports_type

Definition at line 1366 of file flow_graph.h.

## Constructor & Destructor Documentation

## split_node() [1/2]

template<typename TupleType , typename Allocator = cache_aligned_allocator<TupleType>>

__TBB_NOINLINE_SYM tbb::flow::interface11::split_node< TupleType, Allocator >::split_node | ( | graph & | g | ) |

inline explicit

Definition at line 1368 of file flow_graph.h.

: graph_node(g),
my_output_ports(internal::init_output_ports<output_ports_type>::call(g, my_output_ports))
{
tbb::internal::fgt_multioutput_node<N>(CODEPTR(), tbb::internal::FLOW_SPLIT_NODE, &this->my_graph,
static_cast<receiver<input_type> *>(this), this->output_ports());
}

References CODEPTR, tbb::flow::interface11::graph_node::my_graph, and tbb::flow::interface11::split_node< TupleType, Allocator >::output_ports().

Here is the call graph for this function:

## split_node() [2/2]

template<typename TupleType , typename Allocator = cache_aligned_allocator<TupleType>>

__TBB_NOINLINE_SYM tbb::flow::interface11::split_node< TupleType, Allocator >::split_node | ( | const split_node< TupleType, Allocator > & | other | ) |

inline

Definition at line 1383 of file flow_graph.h.

: graph_node(other.my_graph), base_type(other),
my_output_ports(internal::init_output_ports<output_ports_type>::call(other.my_graph, my_output_ports))
{
tbb::internal::fgt_multioutput_node<N>(CODEPTR(), tbb::internal::FLOW_SPLIT_NODE, &this->my_graph,
static_cast<receiver<input_type> *>(this), this->output_ports());
}

References CODEPTR, tbb::flow::interface11::graph_node::my_graph, and tbb::flow::interface11::split_node< TupleType, Allocator >::output_ports().

Here is the call graph for this function:

## Member Function Documentation

## graph_reference()

template<typename TupleType , typename Allocator = cache_aligned_allocator<TupleType>>

graph& tbb::flow::interface11::split_node< TupleType, Allocator >::graph_reference | ( |  | ) | const

inline protected virtual

Implements tbb::flow::interface11::internal::untyped_receiver.

Definition at line 1412 of file flow_graph.h.

{
return my_graph;
}

References tbb::flow::interface11::graph_node::my_graph.

## output_ports()

template<typename TupleType , typename Allocator = cache_aligned_allocator<TupleType>>

output_ports_type& tbb::flow::interface11::split_node< TupleType, Allocator >::output_ports | ( |  | ) |

inline

Definition at line 1397 of file flow_graph.h.

{ return my_output_ports; }

References tbb::flow::interface11::split_node< TupleType, Allocator >::my_output_ports.

Referenced by tbb::flow::interface11::split_node< TupleType, Allocator >::split_node(), and tbb::flow::interface11::split_node< TupleType, Allocator >::try_put_task().

Here is the caller graph for this function:

## reset_node()

template<typename TupleType , typename Allocator = cache_aligned_allocator<TupleType>>

void tbb::flow::interface11::split_node< TupleType, Allocator >::reset_node | ( | reset_flags | f | ) |

inline protected virtual

Implements tbb::flow::interface11::graph_node.

Definition at line 1405 of file flow_graph.h.

{
if (f & rf_clear_edges)
internal::clear_element<N>::clear_this(my_output_ports);
__TBB_ASSERT(!(f & rf_clear_edges) || internal::clear_element<N>::this_empty(my_output_ports), "split_node reset failed");
}

References __TBB_ASSERT, internal::clear_element< N >::clear_this(), tbb::flow::interface11::split_node< TupleType, Allocator >::my_output_ports, and tbb::flow::interface11::rf_clear_edges.

Here is the call graph for this function:

## reset_receiver()

template<typename TupleType , typename Allocator = cache_aligned_allocator<TupleType>>

void tbb::flow::interface11::split_node< TupleType, Allocator >::reset_receiver | ( | reset_flags | f | ) |

inline protected virtual

put receiver back in initial state

Implements tbb::flow::interface11::internal::untyped_receiver.

Definition at line 1411 of file flow_graph.h.

{}

## try_put_task()

template<typename TupleType , typename Allocator = cache_aligned_allocator<TupleType>>

task* tbb::flow::interface11::split_node< TupleType, Allocator >::try_put_task | ( | const TupleType & | t | ) |

inline protected virtual

Put item to successor; return task to run the successor if possible.

Implements tbb::flow::interface11::receiver< TupleType >.

Definition at line 1400 of file flow_graph.h.

{
// Sending split messages in parallel is not justified, as overheads would prevail.
// Also, we do not have successors here. So we just tell the task returned here is successful.
return internal::emit_element<N>::emit_this(this->my_graph, t, output_ports());
}

References internal::emit_element< N >::emit_this(), tbb::flow::interface11::graph_node::my_graph, and tbb::flow::interface11::split_node< TupleType, Allocator >::output_ports().

Here is the call graph for this function:

## Member Data Documentation

## my_output_ports

template<typename TupleType , typename Allocator = cache_aligned_allocator<TupleType>>

output_ports_type tbb::flow::interface11::split_node< TupleType, Allocator >::my_output_ports

private

Definition at line 1436 of file flow_graph.h.

Referenced by tbb::flow::interface11::split_node< TupleType, Allocator >::output_ports(), and tbb::flow::interface11::split_node< TupleType, Allocator >::reset_node().

## N

template<typename TupleType , typename Allocator = cache_aligned_allocator<TupleType>>

const int tbb::flow::interface11::split_node< TupleType, Allocator >::N = tbb::flow::tuple_size<TupleType>::value

static private

Definition at line 1350 of file flow_graph.h.

The documentation for this class was generated from the following file:

- flow_graph.h

tbb::flow::interface11::split_node::my_output_ports
output_ports_type my_output_ports
Definition: flow_graph.h:1436
CODEPTR
#define CODEPTR()
Definition: _flow_graph_trace_impl.h:297
tbb::flow::interface11::graph_node::graph_node
graph_node(graph &g)
Definition: flow_graph.h:880
__TBB_ASSERT
#define __TBB_ASSERT(predicate, comment)
No-op version of __TBB_ASSERT.
Definition: tbb_stddef.h:165
internal::emit_element::emit_this
static task * emit_this(graph &g, const T &t, P &p)
Definition: _flow_graph_node_impl.h:733
internal::clear_element::clear_this
static void clear_this(P &p)
Definition: _flow_graph_node_impl.h:526
tbb::flow::interface11::graph_node::my_graph
graph & my_graph
Definition: _flow_graph_impl.h:464
internal::init_output_ports
Definition: _flow_graph_node_impl.h:563
tbb::flow::interface11::split_node::base_type
receiver< TupleType > base_type
Definition: flow_graph.h:1351
internal::clear_element
Definition: _flow_graph_node_impl.h:525
tbb::flow::interface11::split_node::output_ports
output_ports_type & output_ports()
Definition: flow_graph.h:1397
tbb::flow::interface11::rf_clear_edges
Definition: _flow_graph_impl.h:161

Copyright © 2005-2020 Intel Corporation. All Rights Reserved.

Intel, Pentium, Intel Xeon, Itanium, Intel XScale and VTune are registered trademarks or trademarks of Intel Corporation or its subsidiaries in the United States and other countries.

* Other names and brands may be claimed as the property of others.